'use strict';

exports.__esModule = true;

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

exports.default = withProps;

var _isNotProduction = require('is-not-production');

var _isNotProduction2 = _interopRequireDefault(_isNotProduction);

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _helpers = require('./internals/helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function objectToTransformer(object) {
  return function () {
    return object;
  };
}

function withProps(propsCreator) {
  var propsCreatorIsFunction = (0, _helpers.isFunction)(propsCreator);
  if (_isNotProduction2.default) {
    (0, _warning2.default)(propsCreatorIsFunction || (0, _helpers.isObject)(propsCreator), 'withProps expects a function or object');
  }
  propsCreator = propsCreatorIsFunction ? propsCreator : objectToTransformer(propsCreator);
  return function transform() {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var props = args[0];

    if (_isNotProduction2.default) {
      (0, _warning2.default)((0, _helpers.isObject)(props) || (0, _helpers.isNil)(props), 'First argument must be an object like');
    }
    return (0, _assign2.default)({}, props, propsCreator.apply(this, args));
  };
}
module.exports = exports['default'];